<template>
  <MainTemplate>
    <template #topBar>
      <div class="flex flex-row items-center justify-between pt-5 pb-3 px-7">
        <h1 class="font-bold text-xl h-8">Kommunikationsarten</h1>
      </div>
    </template>
    <template #diffMain>
      <div class="flex flex-col gap-4 h-full pl-7">
        <div class="flex flex-col gap-2 grow overflow-y-scroll pr-7">
          <CommunicationTypeListItem
            v-for="communicationType in communicationTypes"
            :key="communicationType.id"
            :communicationType="communicationType"
          />
        </div>
        <div class="flex flex-row gap-4">
          <button v-if="can('create', 'settings', 'communication_type')" primary class="!w-fit" @click="openCreateModal">
            Kommunikationsart erstellen
          </button>
        </div>
      </div>
    </template>
  </MainTemplate>
</template>

<script setup lang="ts">
import { defineComponent, defineAsyncComponent, markRaw } from "vue";
import { mapState, mapActions } from "pinia";
import MainTemplate from "@/templates/Main.vue";
import { useCommunicationTypeStore } from "@/stores/admin/settings/communicationType";
import CommunicationTypeListItem from "@/components/admin/settings/communicationType/CommunicationTypeListItem.vue";
import { useModalStore } from "@/stores/modal";
import { useAbilityStore } from "@/stores/ability";
</script>

<script lang="ts">
export default defineComponent({
  computed: {
    ...mapState(useCommunicationTypeStore, ["communicationTypes"]),
    ...mapState(useAbilityStore, ["can"]),
  },
  mounted() {
    this.fetchCommunicationTypes();
  },
  methods: {
    ...mapActions(useCommunicationTypeStore, ["fetchCommunicationTypes"]),
    ...mapActions(useModalStore, ["openModal"]),
    openCreateModal() {
      this.openModal(
        markRaw(
          defineAsyncComponent(
            () => import("@/components/admin/settings/communicationType/CreateCommunicationTypeModal.vue")
          )
        )
      );
    },
  },
});
</script>
